/*
*	Copyright (C) 2009	Marlon Rodriguez
*
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU Library General Public License version 2 as
*	published by the Free Software Foundation
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details
*
*	You should have received a copy of the GNU Library General Public
*	License along with this program; if not, write to the
*	Free Software Foundation, Inc.,
*	51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*
*		Author: Marlon Rodriguez
*		Date: 08/14/2009
*		ver: 0.5
*	Used the original Megatokyo comic plugin by Lionel Chauvin and
*	the XKCD one plus http://techbase.kde.org/Development/Tutorials/Plasma/ComicPlugin
*	to come up with this one that works better with the KDE 4.3's Comic plasmoid.
*/

mainURL = "http://www.megatokyo.com/";

function init()
{
	comic.websiteUrl = "http://www.megatokyo.com/";
	comic.shopUrl = "http://www.megagear.com/";
	comic.comicAuthor = "Frederick M. Gallagher III";
	comic.requestPage(comic.websiteUrl, comic.User);
}

function decodeHTML_Entity(str)
{
	/*Definitively do not need them all for this comic, but other languages/comics?
	It would be nice if JavaScript (being a web scripting language) would incorporate a function like this one
	on it's own, well a more complete one of course.  Like python does. */
	
	/* I dont like this method...too lengthy...I would think there is a better way but my brain
	doesnt help me at this moment.  I know I could nest it string.replace().replace().replace;
	but that seems ugly and might even be less efficient.  If you find a better way let me know
	by using the kde.look.org*/
	str = str.replace(/&quot;/g, '"');
	str = str.replace(/&apos;/g, "'");
	str = str.replace(/&amp;/g, "&");
	str = str.replace(/&lt;/g, "<");
	str = str.replace(/&gt;/g, ">");
	str = str.replace(/&nbsp;/g, " ");
	str = str.replace(/&iexcl;/g, "&#161;");
	str = str.replace(/&cent;/g, "&#162;");
	str = str.replace(/&pound;/g, "&#163;");
	str = str.replace(/&curren;/g, "&#164;");
	str = str.replace(/&yen;/g, "&#165;");
	str = str.replace(/&brvbar;/g, "&#166;");
	str = str.replace(/&sect;/g, "&#167;");
	str = str.replace(/&uml;/g, "&#168;");
	str = str.replace(/&copy;/g, "&#169;");
	str = str.replace(/&ordf;/g, "&#170;");
	str = str.replace(/&laquo;/g, "&#171;");
	str = str.replace(/&not;/g, "&#172;");
	str = str.replace(/&shy;/g, "&#173;");
	str = str.replace(/&reg;/g, "&#174;");
	str = str.replace(/&macr;/g, "&#175;");
	str = str.replace(/&deg;/g, "&#176;");
	str = str.replace(/&plusmn;/g, "&#177;");
	str = str.replace(/&sup2;/g, "&#178;");
	str = str.replace(/&sup3;/g, "&#179;");
	str = str.replace(/&acute;/g, "&#180;");
	str = str.replace(/&micro;/g, "&#181;");
	str = str.replace(/&para;/g, "&#182;");
	str = str.replace(/&middot;/g, "&#183;");
	str = str.replace(/&cedil;/g, "&#184;");
	str = str.replace(/&sup1;/g, "&#185;");
	str = str.replace(/&ordm;/g, "&#186;");
	str = str.replace(/&raquo;/g, "&#187;");
	str = str.replace(/&frac14;/g, "&#188;");
	str = str.replace(/&frac12;/g, "&#189;");
	str = str.replace(/&frac34;/g, "&#190;");
	str = str.replace(/&iquest;/g, "&#191;");
	str = str.replace(/&times;/g, "&#215;");
	str = str.replace(/&divide;/g, "&#247;");
	str = str.replace(/&Agrave;/g, "&#192;");
	str = str.replace(/&Aacute;/g, "&#193;");
	str = str.replace(/&Acirc;/g, "&#194;");
	str = str.replace(/&Atilde;/g, "&#195;");
	str = str.replace(/&Auml;/g, "&#196;");
	str = str.replace(/&Aring;/g, "&#197;");
	str = str.replace(/&AElig;/g, "&#198;");
	str = str.replace(/&Ccedil;/g, "&#199;");
	str = str.replace(/&Egrave;/g, "&#200;");
	str = str.replace(/&Eacute;/g, "&#201;");
	str = str.replace(/&Ecirc;/g, "&#202;");
	str = str.replace(/&Euml;/g, "&#203;");
	str = str.replace(/&Igrave;/g, "&#204;");
	str = str.replace(/&Iacute;/g, "&#205;");
	str = str.replace(/&Icirc;/g, "&#206;");
	str = str.replace(/&Iuml;/g, "&#207;");
	str = str.replace(/&ETH;/g, "&#208;");
	str = str.replace(/&Ntilde;/g, "&#209;");
	str = str.replace(/&Ograve;/g, "&#210;");
	str = str.replace(/&Oacute;/g, "&#211;");
	str = str.replace(/&Ocirc;/g, "&#212;");
	str = str.replace(/&Otilde;/g, "&#213;");
	str = str.replace(/&Ouml;/g, "&#214;");
	str = str.replace(/&Oslash;/g, "&#216;");
	str = str.replace(/&Ugrave;/g, "&#217;");
	str = str.replace(/&Uacute;/g, "&#218;");
	str = str.replace(/&Ucirc;/g, "&#219;");
	str = str.replace(/&Uuml;/g, "&#220;");
	str = str.replace(/&Yacute;/g, "&#221;");
	str = str.replace(/&THORN;/g, "&#222;");
	str = str.replace(/&szlig;/g, "&#223;");
	str = str.replace(/&agrave;/g, "&#224;");
	str = str.replace(/&aacute;/g, "&#225;");
	str = str.replace(/&acirc;/g, "&#226;");
	str = str.replace(/&atilde;/g, "&#227;");
	str = str.replace(/&auml;/g, "&#228;");
	str = str.replace(/&aring;/g, "&#229;");
	str = str.replace(/&aelig;/g, "&#230;");
	str = str.replace(/&ccedil;/g, "&#231;");
	str = str.replace(/&egrave;/g, "&#232;");
	str = str.replace(/&eacute;/g, "&#233;");
	str = str.replace(/&ecirc;/g, "&#234;");
	str = str.replace(/&euml;/g, "&#235;");
	str = str.replace(/&igrave;/g, "&#236;");
	str = str.replace(/&iacute;/g, "&#237;");
	str = str.replace(/&icirc;/g, "&#238;");
	str = str.replace(/&iuml;/g, "&#239;");
	str = str.replace(/&eth;/g, "&#240;");
	str = str.replace(/&ntilde;/g, "&#241;");
	str = str.replace(/&ograve;/g, "&#242;");
	str = str.replace(/&oacute;/g, "&#243;");
	str = str.replace(/&ocirc;/g, "&#244;");
	str = str.replace(/&otilde;/g, "&#245;");
	str = str.replace(/&oslash;/g, "&#248;");
	str = str.replace(/&ugrave;/g, "&#249;");
	str = str.replace(/&uacute;/g, "&#250;");
	str = str.replace(/&yacute;/g, "&#253;");
	str = str.replace(/&thorn;/g, "&#254;");
	str = str.replace(/&yuml;/g, "&#255;");
	str = str.replace(/&forall;/g, "&#8704;");
	str = str.replace(/&part;/g, "&#8706;");
	str = str.replace(/&exists;/g, "&#8707;");
	str = str.replace(/&empty;/g, "&#8709;");
	str = str.replace(/&nabla;/g, "&#8711;");
	str = str.replace(/&isin;/g, "&#8712;");
	str = str.replace(/&notin;/g, "&#8713;");
	str = str.replace(/&ni;/g, "&#8715;");
	str = str.replace(/&prod;/g, "&#8719;");
	str = str.replace(/&sum;/g, "&#8721;");
	str = str.replace(/&minus;/g, "&#8722;");
	str = str.replace(/&lowast;/g, "&#8727;");
	str = str.replace(/&radic;/g, "&#8730;");
	str = str.replace(/&prop;/g, "&#8733;");
	str = str.replace(/&infin;/g, "&#8734;");
	str = str.replace(/&ang;/g, "&#8736;");
	str = str.replace(/&and;/g, "&#8743;");
	str = str.replace(/&or;/g, "&#8744;");
	str = str.replace(/&cap;/g, "&#8745;");
	str = str.replace(/&cup;/g, "&#8746;");
	str = str.replace(/&int;/g, "&#8747;");
	str = str.replace(/&there4;/g, "&#8756;");
	str = str.replace(/&sim;/g, "&#8764;");
	str = str.replace(/&cong;/g, "&#8773;");
	str = str.replace(/&asymp;/g, "&#8776;");
	str = str.replace(/&ne;/g, "&#8800;");
	str = str.replace(/&equiv;/g, "&#8801;");
	str = str.replace(/&le;/g, "&#8804;");
	str = str.replace(/&ge;/g, "&#8805;");
	str = str.replace(/&sub;/g, "&#8834;");
	str = str.replace(/&sup;/g, "&#8835;");
	str = str.replace(/&nsub;/g, "&#8836;");
	str = str.replace(/&sube;/g, "&#8838;");
	str = str.replace(/&supe;/g, "&#8839;");
	str = str.replace(/&oplus;/g, "&#8853;");
	str = str.replace(/&otimes;/g, "&#8855;");
	str = str.replace(/&perp;/g, "&#8869;");
	str = str.replace(/&sdot;/g, "&#8901;");
	str = str.replace(/&Alpha;/g, "&#913;");
	str = str.replace(/&Beta;/g, "&#914;");
	str = str.replace(/&Gamma;/g, "&#915;");
	str = str.replace(/&Delta;/g, "&#916;");
	str = str.replace(/&Epsilon;/g, "&#917;");
	str = str.replace(/&Zeta;/g, "&#918;");
	str = str.replace(/&Eta;/g, "&#919;");
	str = str.replace(/&Theta;/g, "&#920;");
	str = str.replace(/&Iota;/g, "&#921;");
	str = str.replace(/&Kappa;/g, "&#922;");
	str = str.replace(/&Lambda;/g, "&#923;");
	str = str.replace(/&Mu;/g, "&#924;");
	str = str.replace(/&Nu;/g, "&#925;");
	str = str.replace(/&Xi;/g, "&#926;");
	str = str.replace(/&Omicron;/g, "&#927;");
	str = str.replace(/&Pi;/g, "&#928;");
	str = str.replace(/&Rho;/g, "&#929;");
	str = str.replace(/&Sigma;/g, "&#931;");
	str = str.replace(/&Tau;/g, "&#932;");
	str = str.replace(/&Upsilon;/g, "&#933;");
	str = str.replace(/&Phi;/g, "&#934;");
	str = str.replace(/&Chi;/g, "&#935;");
	str = str.replace(/&Psi;/g, "&#936;");
	str = str.replace(/&Omega;/g, "&#937;");
	str = str.replace(/&alpha;/g, "&#945;");
	str = str.replace(/&beta;/g, "&#946;");
	str = str.replace(/&gamma;/g, "&#947;");
	str = str.replace(/&delta;/g, "&#948;");
	str = str.replace(/&epsilon;/g, "&#949;");
	str = str.replace(/&zeta;/g, "&#950;");
	str = str.replace(/&eta;/g, "&#951;");
	str = str.replace(/&theta;/g, "&#952;");
	str = str.replace(/&iota;/g, "&#953;");
	str = str.replace(/&kappa;/g, "&#954;");
	str = str.replace(/&lambda;/g, "&#955;");
	str = str.replace(/&mu;/g, "&#956;");
	str = str.replace(/&nu;/g, "&#957;");
	str = str.replace(/&xi;/g, "&#958;");
	str = str.replace(/&omicron;/g, "&#959;");
	str = str.replace(/&pi;/g, "&#960;");
	str = str.replace(/&rho;/g, "&#961;");
	str = str.replace(/&sigmaf;/g, "&#962;");
	str = str.replace(/&sigma;/g, "&#963;");
	str = str.replace(/&tau;/g, "&#964;");
	str = str.replace(/&upsilon;/g, "&#965;");
	str = str.replace(/&phi;/g, "&#966;");
	str = str.replace(/&chi;/g, "&#967;");
	str = str.replace(/&psi;/g, "&#968;");
	str = str.replace(/&omega;/g, "&#969;");
	str = str.replace(/&thetasym;/g, "&#977;");
	str = str.replace(/&upsih;/g, "&#978;");
	str = str.replace(/&piv;/g, "&#982;");
	str = str.replace(/&OElig;/g, "&#338;");
	str = str.replace(/&oelig;/g, "&#339;");
	str = str.replace(/&Scaron;/g, "&#352;");
	str = str.replace(/&scaron;/g, "&#353;");
	str = str.replace(/&Yuml;/g, "&#376;");
	str = str.replace(/&fnof;/g, "&#402;");
	str = str.replace(/&circ;/g, "&#710;");
	str = str.replace(/&tilde;/g, "&#732;");
	str = str.replace(/&ensp;/g, "&#8194;");
	str = str.replace(/&emsp;/g, "&#8195;");
	str = str.replace(/&thinsp;/g, "&#8201;");
	str = str.replace(/&zwnj;/g, "&#8204;");
	str = str.replace(/&zwj;/g, "&#8205;");
	str = str.replace(/&lrm;/g, "&#8206;");
	str = str.replace(/&rlm;/g, "&#8207;");
	str = str.replace(/&ndash;/g, "&#8211;");
	str = str.replace(/&mdash;/g, "&#8212;");
	str = str.replace(/&lsquo;/g, "&#8216;");
	str = str.replace(/&rsquo;/g, "&#8217;");
	str = str.replace(/&sbquo;/g, "&#8218;");
	str = str.replace(/&ldquo;/g, "&#8220;");
	str = str.replace(/&rdquo;/g, "&#8221;");
	str = str.replace(/&bdquo;/g, "&#8222;");
	str = str.replace(/&dagger;/g, "&#8224;");
	str = str.replace(/&Dagger;/g, "&#8225;");
	str = str.replace(/&bull;/g, "&#8226;");
	str = str.replace(/&hellip;/g, "&#8230;");
	str = str.replace(/&permil;/g, "&#8240;");
	str = str.replace(/&prime;/g, "&#8242;");
	str = str.replace(/&Prime;/g, "&#8243;");
	str = str.replace(/&lsaquo;/g, "&#8249;");
	str = str.replace(/&rsaquo;/g, "&#8250;");
	str = str.replace(/&oline;/g, "&#8254;");
	str = str.replace(/&euro;/g, "&#8364;");
	str = str.replace(/&trade;/g, "&#8482;");
	str = str.replace(/&larr;/g, "&#8592;");
	str = str.replace(/&uarr;/g, "&#8593;");
	str = str.replace(/&rarr;/g, "&#8594;");
	str = str.replace(/&darr;/g, "&#8595;");
	str = str.replace(/&harr;/g, "&#8596;");
	str = str.replace(/&crarr;/g, "&#8629;");
	str = str.replace(/&lceil;/g, "&#8968;");
	str = str.replace(/&rceil;/g, "&#8969;");
	str = str.replace(/&lfloor;/g, "&#8970;");
	str = str.replace(/&rfloor;/g, "&#8971;");
	str = str.replace(/&loz;/g, "&#9674;");
	str = str.replace(/&spades;/g, "&#9824;");
	str = str.replace(/&clubs;/g, "&#9827;");
	str = str.replace(/&hearts;/g, "&#9829;");
	str = str.replace(/&diams;/g, "&#9830;");
	
	//replace all HTML numeric entities with the Charcode
	//came up with this method looking at:
	// http://bytes.com/topic/javascript/answers/152866-decoding-numeric-html-entities
	str = str.replace( /&#(\d+);/g,function(wholematch, match1){return String.fromCharCode(match1);});
	return str;
}

function pageRetrieved(id, data)
{
	if (id == comic.User) {
		var re = new RegExp('<img align="middle" src="strips/(\\d+)\.[a-z,A-Z]*" alt=');
		var match = re.exec(data);
		if ( match != null ) {
			comic.lastIdentifier = match[1];
			comic.websiteUrl = mainURL + "strip/" + comic.identifier;
			comic.requestPage(comic.websiteUrl, comic.Page);
		} else {
			comic.error();
		}
	}
	if (id == comic.Page) {
		var re = new RegExp('<img align="middle" src="(strips/\\d+\.[a-z,A-Z]*)" alt=');
		var match = re.exec(data);
		if (match != null) {
			comic.requestPage(mainURL + match[1], comic.Image);
		} else {
			comic.error();
			return;
		}
		//title
		re = new RegExp('<div id="title">"([^\"]+)"</div>');
		match = re.exec(data);
		if (match != null) {
			comic.title = match[1];
		}
		//Alternate text
		re = new RegExp('<img align="middle" src="strips/\\d+\.[a-z,A-Z]*" alt="Strip \\d+" title="([^\"]+)"');
		match = re.exec(data);
		if (match != null) {
			comic.additionalText = decodeHTML_Entity(match[1]);
		}
	}
}
