/*
 *   Copyright (C) 2010 Philipp Hahn <pmhahn+kde pmhahn de>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

var findNewDate = new Boolean();
const mainPage = "http://www.babyblues.com/";
const archive = mainPage + "/archive/index.php?formname=getstrip&GoToDay=";

function init() {
	comic.comicAuthor = "\"Rick Kirkman\", \"Jerry Scott\"";
	comic.firstIdentifier = "1996-01-01";
	comic.websiteUrl = mainPage;
	comic.shopUrl = "http://www.babyblues.com/bbstore.html";

	if (comic.identifier.date >= comic.lastIdentifier.date) {
		print(mainPage);
		comic.requestPage(mainPage, comic.User);
	} else {
		var url = archive + comic.identifier.toString("MM/dd/yyyy");
		print(url);
		comic.requestPage(url, comic.Page);
	}
}

function pageRetrieved(id, data) {
	// find most recent strip
	if (id == comic.User) {
		var re = new RegExp("<option value=\"(\\d{4}-\\d{2}-\\d{2})\" selected=\"selected\">");
		var match = re.exec(data);
		if (match != null) {
			comic.lastIdentifier = date.fromString(match[1], "yyyy-MM-dd");
			comic.websiteUrl = archive + comic.lastIdentifier.toString("MM/dd/yyyy");
			print(comic.websiteUrl);
			comic.requestPage(comic.websiteUrl, comic.Page);
		} else {
			comic.error();
		}
	} else if (id == comic.Page) {
		var re = new RegExp("<div class=\"comic\">\\s*<img[^\"]+src=\"(http://([^/]+)/[^\"]+)\"");
		var match = re.exec(data);
		if (match != null) {
			print(match[1]);
			comic.requestPage(match[1], comic.Image, {"referrer":comic.websiteUrl});
		} else {
			comic.error();
			return;
		}

		re = new RegExp("<a id=\"prevStripLink\" href=\"index.php[^\"]+GoToDay=(\\d{2}/\\d{2}/\\d{4})\"");
		match = re.exec(data);
		if (match != null) {
			comic.previousIdentifier = date.fromString(match[1], "MM/dd/yyyy");
		}

		re = new RegExp("<a id=\"nextStripLink\" href=\"index.php[^\"]+GoToDay=(\\d{2}/\\d{2}/\\d{4})\"");
		match = re.exec(data);
		if (match != null) {
			comic.nextIdentifier = date.fromString(match[1], "MM/dd/yyyy");
		}

		re = new RegExp("<td +class=\"[^\"]*selected[^\"]*\"[^>]*><a href=\"index.php[^\"]+GoToDay=(\\d{2}/\\d{2}/\\d{4})\"");
		match = re.exec(data);
		if (match != null) {
			comic.websiteUrl = archive + match[1];
		}
	}
}
