/*
 *   boulet plugin for comic plasma widget
 *   Copyright (C) 2011 Mathieu Guilbaud <mathieu@guim.info>
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

var urlArray = new Array();
var tmpImage;
const mainPage = "http://www.bouletcorp.com/lite/index.php?";
const imgSrc = "http://www.bouletcorp.com/";

function init() {
	comic.comicAuthor = "Boulet";
	comic.firstIdentifier = "2005-08-02";
	comic.websiteUrl = "http://bouletcorp.com/lite/";
	comic.shopUrl = "http://bouletcorp.com/";
	
	var url = mainPage;
	if (comic.identifier.date < date.currentDate().date) {
		url += comic.identifier.toString("'&annee='yyyy'&mois='MM'&jour='dd");
	}
	
	comic.requestPage(url, comic.Page);
}

function pageRetrieved(id, data) {
	if (id == comic.Page) {
		// current
		var re = new RegExp("<img src=\\.\\./(blog/archive/\\d+\\.jpg)");
		var match = re.exec(data);
		if (match != null) {
			url = imgSrc + match[1];
			urlArray.push(url);
		} else {
			comic.error();
		}
		
		// bonus
		re = new RegExp("<td class=\"image\"><img src=\"([^\"]+)\" hspace");
		match = re.exec(data);
		if (match != null) {
			urlArray.push(match[1]);
		}
		comic.requestPage(urlArray.pop(), comic.Image);
		
		// prev
		re = new RegExp("<a href=index\\.php\\?&(annee=\\d+&mois=\\d+&jour=\\d+)><img src=\"histoireprec\\.jpg\"");
		match = re.exec(data);
		if (match != null) {
			comic.previousIdentifier = date.fromString(match[1], "'annee='yyyy'&mois='MM'&jour='dd");
		}
		
		// next
		re = new RegExp("<a href=index\\.php\\?&(annee=\\d+&mois=\\d+&jour=\\d+)><img src=\"histoiresuiv\\.jpg\"");
		match = re.exec(data);
		if (match != null) {
			comic.nextIdentifier = date.fromString(match[1], "'annee='yyyy'&mois='MM'&jour='dd");
		}
		
		// title
		re = new RegExp("<td class=\"titre\"><br><br><b>([^<]+)</b>");
		match = re.exec(data);
		if (match != null) {
			comic.title = match[1];
			comic.additionalText = match[1];
		}
	}
	
	if (id == comic.Image) {
		// add bonus image under main image
		if (tmpImage != null) {
			comic.combine(tmpImage, comic.Bottom);
		}
		if (urlArray.length > 0) {
			tmpImage = comic.image();
			comic.requestPage(urlArray.pop(), comic.Image);
		}
	}
}

