/***************************************************************************
 *   Copyright (C) 2018 Matthias Fuchs <mat69@gmx.net>                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

const homepage = "https://cad-comic.com";

function init()
{
    comic.comicAuthor = "Tim Buckley";
    comic.firstIdentifier = "nice-melon";
    comic.shopUrl = "https://sharkrobot.com/collections/ctrl-alt-del";


    if (comic.identifierSpecified) {
        comic.websiteUrl = homepage + "/comic/" + comic.identifier;
        comic.requestPage(comic.websiteUrl, comic.Page);
    } else {
        comic.requestPage(homepage, comic.User);
    }
}

function pageRetrieved(id, data)
{
    //find the next id if the next is the most recent
    if (id == comic.User) {
        var re = new RegExp('<a class="url-href" href="https://cad-comic.com/comic/([^/]+)/"><img class="comic-display"');
        var match = re.exec(data);
        if (match != null) {
            comic.lastIdentifier = match[1];
            comic.websiteUrl = homepage + "/comic/" + comic.identifier;
            comic.requestPage(comic.websiteUrl, comic.Page);
        } else {
            print("Could not find the most recent strip.");
            comic.error();
        }
    }
    if (id == comic.Page) {
        var re = new RegExp('href="https://cad-comic.com/comic/([^/]+)/" rel="next"');
        var match = re.exec(data);
        if (match != null) {
            comic.nextIdentifier = match[1];
        }

        re = new RegExp('href="https://cad-comic.com/comic/([^/]+)/" rel="prev"');
        match = re.exec(data);
        if (match != null) {
            comic.previousIdentifier = match[1];
        }

        re = new RegExp(comic.identifier + '/"><img src="(https://cad-comic.com/wp-content/uploads/[^"]+)"');
        match = re.exec(data);
        if (match != null) {
            comic.requestPage(match[1], comic.Image);
        } else {
            print("Could not find the image url.");
            comic.error();
            return;
        }
    }
}
