/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/
 
function init() {
    comic.comicAuthor = "Richard Stevens";
    comic.baseUrl = "http://dieselsweeties.com/";
    comic.websiteUrl = "http://dieselsweeties.com/";
    
    comic.firstIdentifier = "a1";

    comic.requestPage(comic.websiteUrl, comic.User);
}

function pageRetrieved(id, data) {

    if (id == comic.User) {
        var re = new RegExp("src=\"/strips666/ds(\\d+).(\\S\\S\\S)");
        var match = re.exec(data);
        if (match != null) {
            comic.lastIdentifier = match[1];
            if (comic.identifier) {
                setIdentifier(comic.identifier);
            }
            else {
                setIdentifier(comic.lastIdentifier);
            }
            comic.websiteUrl = getUrl(comic.identifier);
            comic.requestPage(comic.websiteUrl, comic.Page);
        }
        else {
            comic.error();
        }
    }
    
    if (id == comic.Page) {
        var re, match, re2, match2;
        
        re = new RegExp(" src=\"/hstrips/(\\d)/(\\d)/(\\d)/(\\d)/(\\d+).(\\S\\S\\S)\"");
        re2 = new RegExp("<img title=\"([^\"]*)\"");
        match = re.exec(data);
        match2 = re2.exec(data);
        if (match != null) {
            comic.requestPage(comic.baseUrl + "hstrips/" + match[1] + "/" + match[2] + "/" + match[3] + "/" + match[4] + "/" + match[5] + "." + match[6], comic.Image);
            if (match2 != null) {
                comic.additionalText = match2[1];
            }
            return;
        }
        
        
        re = new RegExp(" src=\"/strips666/ds(\\d+).(\\S\\S\\S)\"");
        re2 = new RegExp("<img class=\"xomic\" title=\"comic\" alt=\"([^\"]*)\"");
        match = re.exec(data);
        match2 = re2.exec(data);
        if (match != null) {
            comic.requestPage(comic.baseUrl + "strips666/ds" + match[1] + "." + match[2], comic.Image);
            if (match2 != null) {
                comic.additionalText = match2[1];
            }
            return;
        }
        
        comic.error();
    }

}

function setIdentifier(i) {
    var now;
    i = "" + i;
    comic.identifier = i;
    if (i.charAt(0) == "a") {
        now = parseInt(i.replace("a", ""));
        comic.nextIdentifier = "a" + (now + 1);
        comic.previousIdentifier = "a" + (now - 1);
        
        if (now + 1 == 4001) {
            comic.nextIdentifier = "1";
        }
        else if (comic.identifier == comic.firstIdentifier) {
            comic.previousIdentifier = comic.firstIdentifier;
        }
    }
    else {
        now = parseInt(i);
        comic.nextIdentifier = "" + (now + 1);
        comic.previousIdentifier = "" + (now - 1);
        
        if (now - 1 == 0) {
            comic.previousIdentifier = "a4000";
        }
        else if (comic.identifier == comic.lastIdentifier) {
            comic.nextIdentifier = comic.lastIdentifier;
        }
    }
}

function digit(n, i) {
    return Math.floor((n / Math.pow(10, i)) % 10);
}
function pad(n, i) {
    n = "" + n;
    while (n.length < i) {
        n = "0" + n;
    }
    return n;
}

function getUrl(i) {
    var now;
    i = "" + i;
    if (i.charAt(0) == "a") {
        now = parseInt(i.replace("a", ""));
        return comic.baseUrl + "archive/" + now;
    }
    else {
        now = parseInt(i);
        return comic.baseUrl + "ics/" + now + "/";
    }
}

