/*
 * Copyright (c) 2011, David Bolding
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *  - Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *  - Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


const comicsPrefix = "http://www.missmab.com/Comics/Vol_";
const comicsSuffix = ".php";

function init()
{
    comic.comicAuthor = "Amber M. Williams";
    comic.websiteUrl = "http://www.missmab.com";
    comic.shopUrl = "http://www.rcsipublishing.com/store/index.php?main_page=index&cPath=14&zenid=5lmpe9smm5n9dvomkfihc0r8b6";

    comic.requestPage(comic.websiteUrl, comic.User);
}

function pageRetrieved(id, data)
{
    if (id == comic.User) {
        const expLast = new RegExp("SRC=\"Comics/Vol(\\d+)\\.(\\w+)\"");
        const matchLast = expLast.exec(data);
        if (matchLast == null) {
            comic.error();
            return;
        }

        comic.lastIdentifier = matchLast[1];

        // Manage the zero-padding.
        // Identifiers less than 1,000 need to be zero-padded to three places.
        var identString;
        if (comic.identifierSpecified) {
            if (comic.identifier >= 100) {
                identString = comicsPrefix + comic.identifier + comicsSuffix;
            } else if (comic.identifier >= 10) {
                identString = comicsPrefix + "0" + comic.identifier + comicsSuffix;
            } else {
                identString = comicsPrefix + "00" + comic.identifier + comicsSuffix;
            }
        } else {
            identString = comicsPrefix + comic.lastIdentifier + comicsSuffix;
        }

        comic.requestPage(identString, comic.Page);
    } else if (id == comic.Page) {
        const expImage = new RegExp("<IMG\\s+SRC=\"(Vol\\d+\\.\\w+)\"");
        const imageMatch = expImage.exec(data);
        if (imageMatch == null) {
            comic.error();
            return;
        }
        comic.requestPage("http://www.missmab.com/Comics/" + imageMatch[1], comic.Image);

        const expTitle = /<I>(#\d+:)?\s*([^<]+)/;
        const matchTitle = expTitle.exec(data);
        if (matchTitle != null) {
            comic.additionalText = matchTitle[2];
        }
    }
}


