/***************************************************************************
 *   Copyright (C) 2018 Matthias Fuchs <mat69@gmx.net>                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

const homepage = "http://www.duelinganalogs.com";

function init()
{
    comic.firstIdentifier = "luigis-anal-adventure";
    comic.comicAuthor = "Steve Napierski";

    if (comic.identifierSpecified) {
        comic.websiteUrl = homepage + "/comic/" + comic.identifier;
        comic.requestPage(comic.websiteUrl, comic.Page);
    } else {
        comic.requestPage(homepage + "/archive", comic.User);
    }
}

function pageRetrieved(id, data)
{
    //find the identifier of the most recent comic
    if (id == comic.User) {
        var re = new RegExp('id="archive"> <li><a href="http://www.duelinganalogs.com/comic/([^/]+)/"');
        var match = re.exec(data);
        if (match != null) {
            comic.lastIdentifier = match[1];
            comic.websiteUrl = homepage + "/comic/" + comic.identifier;
            comic.requestPage(comic.websiteUrl, comic.Page);
        } else {
            print("Could not get most recent comic.");
            comic.error();
        }
        return;
    }
    //download the comic
    if (id == comic.Page) {
        var re = new RegExp('class="next"> <a href="http://www.duelinganalogs.com/comic/([^/]+)/')
        var match = re.exec(data);
        if (match != null) {
            comic.nextIdentifier = match[1];
        }

        re = new RegExp('class="previous"> <a href="http://www.duelinganalogs.com/comic/([^/]+)/')
        match = re.exec(data);
        if (match != null) {
            comic.previousIdentifier = match[1];
        }

        re = new RegExp('<img src="(http://cdn.duelinganalogs.com/(comics|wp-content/uploads)/[^"]+)".*alt="([^"]*)"');
        match = re.exec(data);
        if (match != null) {
            comic.title = match[4];
            comic.requestPage(match[1], comic.Image);
        } else {
            print("Could not find image.");
            comic.error();
        }
    }
}
