/*
 *   Copyright (C) 2009 Mathias Panzenböck <grosser.meister.morti@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

const GetLast = comic.User;
const GetNext = comic.User + 1;
const comicPrefix = 'http://www.egscomics.com/?date=';

function init() {
	comic.comicAuthor     = 'Dan Shive';
	comic.firstIdentifier = '2002-01-21';
	comic.shopUrl         = 'http://www.egscomics.com/store.page';
	
	if (comic.identifierSpecified) {
		var re = /^next-of-(.*)$/;
		var match = re.exec(comic.identifier);
		if (match == null) {
			comic.requestPage(comicPrefix + comic.identifier, comic.Page);
		}
		else {
			comic.requestPage(comicPrefix + match[1], GetNext);
		}
	}
	else {
		comic.requestPage('http://www.egscomics.com/', GetLast);
	}
}

function pageRetrieved(id, data) {
	if (id == comic.Image) {
		return;
	}
	else if (id == GetNext) {
		var re = /<a href='([^']*)' class='navimg' [^>]*arrow_next/;
		var match = re.exec(data);
		if (match == null) {
			print('*** could not parse next of ' + comic.identifier);
			comic.error();
		}
		else {
			comic.requestPage('http://www.egscomics.com' + match[1], comic.Page);
		}
		return;
	}

	var re = /<img src='(comics\/\d+\/\d+\/(\d\d\d\d)(\d\d)(\d\d)_[^']*)'/;
	var match = re.exec(data);

	if (match == null) {
		print('*** could not parse image of ' + comic.identifier);
		comic.error();
		return;
	}

	// get image
	comic.requestPage('http://www.egscomics.com/' + match[1], comic.Image);
	var comicId = match[2] + '-' + match[3] + '-' + match[4];

	if (id == GetLast) {
		comic.lastIdentifier = comicId;
	}

	if (!comic.identifierSpecified) {
		comic.identifier = comicId;
	}

	comic.websiteUrl = comicPrefix + comicId;

	// get title
	re = /<option value='\d+' selected='selected'>([^<]*)<\/option>/;
	match = re.exec(data);
	if (match != null) {
		comic.title = match[1];
	}

	// get prev link
	re = /<a href='\/\?date=([^']*)' class='navimg' [^>]*arrow_prev/;
	match = re.exec(data);
	if (match != null) {
		comic.previousIdentifier = match[1];
	}

	// get next link
	re = /<a href='([^']*)' class='navimg' [^>]*arrow_next/;
	match = re.exec(data);
	if (match != null) {
		if (match[1] == '/') {
			comic.nextIdentifier = 'next-of-' + comicId;
		}
		else {
			re = /\/\?date=(.*)/;
			match = re.exec(match[1]);
			if (match != null) {
				comic.nextIdentifier = match[1];
			}
		}
	}
}
