/*
 *   Copyright (C) 2009 Mathias Panzenböck <grosser.meister.morti@gmx.net>
 *   Copyright (C) 2010 Roopesh Chander <roop@knurd.in>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

// This plugin has its roots in Mathias Panzenböck's Warrior U plugin

const GetLast     = comic.User;
const mainPage    = 'http://www.flyyoufools.com/';
const comicPrefix = 'http://www.flyyoufools.com/';

function init() {
    // DEBUG // print('*** fyf *** init');
    comic.comicAuthor     = "Saad Akhtar";
    comic.firstIdentifier = "fast-food-is-killing-us";
	
	if (comic.identifierSpecified) {
        // DEBUG // print('*** fyf *** requestPage /' + comic.identifier + ', ' + comic.Page);
		comic.requestPage(comicPrefix + comic.identifier, comic.Page);
	}
    else {
        // DEBUG // print('*** fyf *** requestPage / ' + GetLast);
		comic.requestPage(mainPage, GetLast);
	}
}

function pageRetrieved(id, data) {
    // DEBUG // print('*** fyf *** pageRetrieved ' + id);
	if (id == comic.Image) {
		return;
	}

	var comicId, re, match;
    re = /<a href="http:\/\/www.flyyoufools\.com\/([^"]*)" rel="bookmark"[^>]*>([^<]*)<\/a>/;
    match = re.exec(data);
    if (match != null) {
        comic.identifier = comicId = match[1];
        comic.title = match[2];
    }
    else {
        re = /<title>Nothing found for/;
        match = re.exec(data);
        if (match != null) {
            // in case we were asked for something random,
            // fall back to the main page
            // DEBUG // print('*** fyf *** fallback requestPage / ' + comic.Page);
            comic.requestPage(mainPage, GetLast);
            return;
        } else {
            print('*** error parsing last comic');
            comic.error();
            return;
        }
    }

	if (id == GetLast) {
        comic.lastIdentifier = comicId;
        // DEBUG // print('*** fyf *** requestPage /' + comicId + ', ' + comic.Page);
		comic.requestPage(comicPrefix + comicId, comic.Page); // to get prev id
        return;
    }
	comic.websiteUrl = comicPrefix + comicId;
	
    // find the image
	re = /<img [^>]*src="([^"]*)"/;
    var entrybody = data.slice(data.search(/<div class="entrybody">/));
	match = re.exec(entrybody); // look for the first img in entrybody
	if (match != null) {
        // DEBUG // print('*** fyf *** requestPage img ' + match[1] + ', ' + comic.Image);
		comic.requestPage(match[1], comic.Image);
	}
    else {
        print('*** error parsing image location in:\n'
              + "... "
              + entrybody.slice(0, 300).replace(/[\n\s]+/g, " ")
              + " ...");
        comic.error();
        return;
    }
	
	// find previous link
	re = /<a href="http:\/\/www.flyyoufools\.com\/([^"]*)" rel="prev">/;
	match = re.exec(data);
	if (match != null) {
		comic.previousIdentifier = match[1];
	}
    // DEBUG // print('*** fyf *** previous = ' + comic.previousIdentifier);
	
	// find next link
	re = /<a href="http:\/\/www.flyyoufools\.com\/([^"]*)" rel="next">/;
	match = re.exec(data);
	if (match != null) {
		comic.nextIdentifier = match[1];
	}
    // DEBUG // print('*** fyf *** next = ' + comic.nextIdentifier);
}
