/***************************************************************************
 *   Copyright (C) 2009 Razvan Ionescu <varzanu.de.komodo@gmail.com>       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License          *
 *   version 2 as published by the Free Software Foundation.               *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

function init()
{
    comic.comicAuthor="Salvatore Iovene";
    comic.websiteUrl="http://www.geekherocomic.com/";
    comic.shopUrl="http://www.cafepress.com/geekherocomic";
    comic.firstIdentifier="2008/03/03/03032008/";
    if(comic.identifier)
    {
        comic.websiteUrl+=comic.identifier;
        comic.requestPage(comic.websiteUrl, comic.Page);
        return;
    }
    comic.requestPage(comic.websiteUrl, comic.User);
}

function pageRetrieved(id, data)
{
    if(id==comic.User)
    {
        //get URL of latest comic from homepage
        var re=new RegExp("http://www.geekherocomic.com/(\\d{4}/\\d{2}/\\d{2}/[^/]+/)#comments");
        var match=re.exec(data);
        if(match!=null)
        {
            comic.websiteUrl+=match[1];
            comic.requestPage(comic.websiteUrl, comic.Page);
        }
        else
        {
            comic.error();
            return;
        }
    }
    
    if(id==comic.Page)
    {
        //we're on a post page, get URL of image and display it
        var re_img=new RegExp("<a[^>]+class=\"view-large\"[^>]+href=\'([^\']+)\'[^>]*>");
        var match_img=re_img.exec(data);
        if(match_img!=null)
            comic.requestPage(match_img[1], comic.Image);
        else
        {
            //sometimes there's no "(view large)" image, try to get the <img> from the post
            var re_img2= new RegExp("<img src=\"([^\"]+)\"[^>]alt=\"Geek Hero Comic - A webcomic for geeks: [^\"]+\"");
            var match_img2=re_img2.exec(data);
            if(match_img2!=null)
                comic.requestPage(match_img2[1], comic.Image);
            else
            {
                //well, we've tried getting the image in two different ways, we can bail out
                comic.error();
                return;
            }
        }
        
        //we've got the image, get title, prev and next
        re_title=new RegExp("<h2 class=\"pagetitle\">([^<]+)<");
        match_title=re_title.exec(data);
        if(match_title!=null)
        {
            page_title=match_title[1];
            comic.title=page_title.replace("&nbsp;", " ");//a bit of cleaning up. what's with all the extra nbsp's, Geek Hero?
            comic.additionalText=comic.title;
        }
        re_prev=new RegExp("<a href=\"http://www.geekherocomic.com/([^\"]+)\"><img[^>]+alt=\"<< Previous\"");
        match_prev=re_prev.exec(data);
        if(match_prev!=null)
            comic.previousIdentifier=match_prev[1];
        else
            comic.previousIdentifier=null;
        re_next=new RegExp("<a href=\"http://www.geekherocomic.com/([^\"]+)\"><img[^>]+alt=\"Next >>\"");
        match_next=re_next.exec(data);
        if(match_next!=null)
            comic.nextIdentifier=match_next[1];
        else
            comic.nextIdentifier=null;
    }
}