/*
 *   Copyright (C) 2010 Konrad Gadzicki
 *
 *   Based on the XKCD comic engine by Tobias Koenig <tokoe@kde.org>
 *   and Matthias Fuchs <mat69@gmx.net>
 * 
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

baseurl = "http://www.gunnerkrigg.com";
page_url = "/archive_page.php?comicID=";

function init()
{
  comic.comicAuthor = "Tom Siddell";
  comic.websiteUrl = baseurl;
  comic.shopUrl = "http://www.gunnerkrigg.com/support.html";
  comic.title = "Gunnerkrigg Court";
  
  
  if (comic.identifier == 0) 
  {
    comic.requestPage(comic.websiteUrl + "/index2.php", comic.User);
  } 
  else 
  {    
    comic.websiteUrl = comic.websiteUrl + page_url + comic.identifier;
    comic.requestPage(comic.websiteUrl, comic.Page);  
  }
}

function pageRetrieved(id, data)
{ 
  //get the latest page
  if (id == comic.User)
  {
    // image element see below
    // <img src="http://www.gunnerkrigg.com//comics/00000787.jpg" alt="Chapter 30: Page 25" border="0"/>
    var image_url_exp = new RegExp("<img src=\"(" + baseurl + "//comics/(\\d+).(jpg|gif))\" alt=\"([A-Z][^\"]+)");
    var match = image_url_exp.exec(data);
    
    print(match);
    
    if (match != null)
    {      
      comic.lastIdentifier = match[2];
      comic.requestPage(comic.websiteUrl + page_url + comic.lastIdentifier, comic.Page);
    }
    else
    {
      comic.error();
    }
  }
  
  //get a specific page with identifier
  if (id == comic.Page)
  { 
    // image element see below
    // <img src="http://www.gunnerkrigg.com//comics/00000787.jpg" alt="Chapter 30: Page 25" border="0"/>
    var image_url_exp = new RegExp("<img src=\"(" + baseurl + "//comics/(\\d+).(jpg|gif))\" alt=\"([A-Za-z][^\"]+)");
    var match = image_url_exp.exec(data);
    
    if (match != null)
    {
      //set chapter and page number to title
      comic.title = match[4];
      comic.additionalText = match[4];
      
      //ids are not in order occasionally
      //prev and next have to be set manually
      var prev_exp = new RegExp("<a href=\"http://www.gunnerkrigg.com/archive_page.php\\?comicID=(\\d+)\"><img src=\"images/prev_a");
      var match_prev = prev_exp.exec(data);      
      if (match_prev != null)
      {
	comic.previousIdentifier = match_prev[1];
      }      
      var next_exp = new RegExp("<a href=\"http://www.gunnerkrigg.com/archive_page.php\\?comicID=(\\d+)\"><img src=\"images/next_a");
      var match_next = next_exp.exec(data);
      if (match_next != null)
      {
	comic.nextIdentifier = match_next[1];
      }
      
      //finally get the image
      comic.requestPage(match[1], comic.Image);
    }
    else
    {
      comic.error();
    }
  }
  if (id == comic.Image)
  {
    // nah, do nothing and have nice cpu cycle
  }
}