/***************************************************************************
 *   Copyright (C) 2018 Matthias Fuchs <mat69@gmx.net>                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

const homepage = "https://www.kevinandkell.com/";

function init()
{
    comic.comicAuthor = "Bill Holbrook";
    comic.firstIdentifier = "1995-09-03";
    comic.websiteUrl = homepage;
    comic.shop = homepage + "support/";

    comic.requestPage( comic.websiteUrl, comic.User );
}

function websiteForId(id)
{
    return homepage + id.toString("yyyy") + "/kk" + id.toString("MMdd") + ".html";
}

function pageRetrieved( id, data )
{
    //find the url of the most recent comic
    if ( id == comic.User ) {
        const expDate = new RegExp("<a href=\"/\\d{4}/strips/kk(\\d{8})[^\"]+\" id=\"comicstrip\"");
        const matchDate = expDate.exec ( data );
        if ( matchDate != null ) {
            comic.lastIdentifier = date.fromString( matchDate[1], "yyyyMMdd" );
            comic.websiteUrl = websiteForId(comic.identifier);

            comic.requestPage( comic.websiteUrl, comic.Page );
        } else {
            comic.error();
        }
    }
    if ( id == comic.Page ) {

        const expImage = new RegExp("<a href=\"([^\"]+)\" id=\"comicstrip\"");
        const matchImage = expImage.exec( data );
        if ( matchImage != null ) {
            var url = homepage + matchImage[1];
            comic.requestPage( url, comic.Image );
        } else {
            comic.error();
        }

        const expTitle = new RegExp( "id=\"comicstripCaption\">&quot;([^<]+)&quot;" );
        const matchTitle = expTitle.exec( data );
        if ( matchTitle != null ) {
            comic.title = matchTitle[1];
        }

        const expPrev = new RegExp( "<li id=\"prevstrip\"><a href=\"/(\\d{4}/kk\\d{4})" );
        const matchPrev = expPrev.exec( data );
        if ( matchPrev != null ) {
            comic.previousIdentifier = date.fromString( matchPrev[1].replace("/kk", ""), "yyyyMMdd" );
        }

        const expNext = new RegExp( "<li id=\"nextstrip\"><a href=\"/(\\d{4}/kk\\d{4})" );
        const matchNext = expNext.exec( data );
        if ( matchNext != null ) {
            comic.nextIdentifier = date.fromString( matchNext[1].replace("/kk", ""), "yyyyMMdd" );
        } else if ( comic.identifier.toJulianDay() < comic.lastIdentifier.toJulianDay() ) {
            comic.nextIdentifier = comic.lastIdentifier;
        }
    }
}
