/***************************************************************************
*   Copyright (C) 2009 Alvaro Tanarro Santamaria <tanarro@gmail.com>      *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
***************************************************************************/

function init()
{
  comic.comicAuthor = "Daniel Garcia Moreno (danigm)";
  comic.firstIdentifier = "0279-presentacion.html";
  comic.websiteUrl = "http://tira.danigm.net/index.html";
  
  //check if the comic.identifier is empty, there are other ways as well like checking its length
  if (comic.identifier != new String()) {
    comic.websiteUrl = "http://tira.danigm.net/all/" + comic.identifier;
    comic.requestPage(comic.websiteUrl, comic.Page);
  } else {
    comic.requestPage(comic.websiteUrl, comic.User);
  }
}

function pageRetrieved(id, data)
{
  //find the most recent comic
  if (id == comic.User) {
    var re = new RegExp("<a href=\"all/([^\"]+)\"");
    var match = re.exec(data);
    if (match != null) {
      comic.lastIdentifier = match[1];
      comic.identifier = comic.lastIdentifier;
      comic.websiteUrl = "http://tira.danigm.net/all/" + comic.identifier;
      comic.requestPage(comic.websiteUrl, comic.Page);
    } else {
      comic.error();
    }
  }
  //get the comic image and all other available information
  if (id == comic.Page) {
    //here the title of the strip is spread across two places on the website
    var re = new RegExp("<title>([^&]+)&mdash; Tira de LinuxHispano</title>");
    var match = re.exec(data);
    if (match != null) {
      comic.title = match[1];
    }
    
    //getting the image and the second part of the title
    re = new RegExp("<img alt=\"([^\"]+)\"");
    match = re.exec(data);
    if (match != null) {
      comic.requestPage("http://tira.danigm.net/all/" + match[1], comic.Image);
    } else {
      comic.error();
      return;
    }
    //getting the previous identifier
    re = new RegExp("<h4>Next topic</h4>[^\<]+<p class=\"topless\"><a href=\"([^\"]+)\"");
    match = re.exec(data);
    if (match != null) {
      comic.previousIdentifier = match[1];
    }
    //getting the next identifier
    re = new RegExp("<h4>Previous topic</h4>[^\<]+<p class=\"topless\"><a href=\"([^\"]+)\"");
    match = re.exec(data);
    if (match != null) { // this is the last
      if (match[1] !=  "../index.html") {
        comic.nextIdentifier = match[1];
      }
    }
  }
} 
