/***************************************************************************
 *   Copyright (C) 2008 Matthias Fuchs <mat69@gmx.net>                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

const FindNewDate = comic.User + 1;
const mainPage = "http://www.little-gamers.com/";

function init()
{
    comic.comicAuthor = "Christian Fundin, Pontus Madsen";
    comic.firstIdentifier = "2000-12-01";

    comic.requestPage( mainPage, FindNewDate );
}

function pageRetrieved(id, data)
{
    //find new date
    if ( id == FindNewDate ) {
        const expDate = new RegExp( "comics/(\\d{4}-\\d{2}-\\d{2})" );
        const matchDate = expDate.exec ( data );
        if ( matchDate != null ) {
            comic.lastIdentifier = date.fromString( matchDate[1], date.ISODate );
            var url = mainPage + comic.identifier.toString( "yyyy/MM/dd/" );
            comic.requestPage( url, comic.User );
        } else {
            comic.error();
        }
    }
    //find the url to the comic website
    if ( id == comic.User ) {http://www.little-gamers.com/2010/10/01/this-is-obviously-not-a-christian-game/#comments
        const expUrl = new RegExp( "<a href=\"(" + mainPage + comic.identifier.toString( "yyyy/MM/dd/" ) + "[^\"]+)\"><img" );
        const matchUrl = expUrl.exec( data );
        if ( matchUrl != null ) {
            comic.websiteUrl = matchUrl[1];
            comic.requestPage( comic.websiteUrl, comic.Page );
        } else {
            comic.error();
        }
    }
    if ( id == comic.Page ) {
        const expImage = new RegExp( "<div id=\"comic-middle\"><img src=\"([^\"]+)\" alt=\"([^\"]+)\"" );
        const matchImage = expImage.exec( data );
        if ( matchImage != null ) {
            url = matchImage[1];
            comic.title = matchImage[2];
            comic.requestPage( url, comic.Image );
        } else {
            comic.error();
            return;
        }

        const expPrev = new RegExp( "<a id=\"comic-nav-prev-link\" href=\"" + mainPage + "(\\d{4}/\\d{2}/\\d{2}/)[^\"]+\"" );
        const matchPrev = expPrev.exec( data );
        if ( matchPrev != null ) {
            comic.previousIdentifier = date.fromString( matchPrev[1], "yyyy/MM/dd/" );
        }

        const expNext = new RegExp( "<a id=\"comic-nav-next-link\" href=\"" + mainPage + "(\\d{4}/\\d{2}/\\d{2}/)[^\"]+\"" );
        const matchNext = expNext.exec( data );
        if ( matchNext != null ) {
            comic.nextIdentifier = date.fromString( matchNext[1], "yyyy/MM/dd/" );
        }
    }
}
