/*
 *   Copyright (C) 2007 Lionelc Chauvin <megabigbug@yahoo.fr>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
 
URL = "http://www.megatokyo.fr/";

function websiteUrl(id)
{
  if(id ==0)
      return URL;

  if (id<10)
  {
    return URL + "planche/fr000" + (id);
  }
  else if (id<100)
  {
    return URL + "planche/fr00" + (id);
  }
  else if (id< 1000)
  {
    return URL + "planche/fr0" + (id);
  }
  else return URL + "planche/fr" + (id);

}


//init function
function init()
{
    print("** Init() **");    
  
    //we get the current ID, 0 if its first time !
    var currentID = comic.identifier;
    print("current ID :"+ currentID);
    
    //our first id is always 1...
    comic.firstIdentifier = 1;
     
     //so if we are on ID 0, first time so go to take the latest image !
    if (currentID == 0) {
        print("loading the latest image...");
        comic.requestPage(websiteUrl(0), comic.User);
    }
    else        
    {        
    	comic.requestPage(websiteUrl(currentID), comic.Page);
    }
}

function getTitle(data)
{
    var title = "";
    var reTitle = new RegExp('<title>.* - .* - (.+)</title>');
    var match = reTitle.exec(data);
    if ( match != null ) {	     
	title = match[1];
        
	print("title :" +title);        
    } else {
	print("title not found !");
    }
    return title;
}


function getLastID(data)
{
    var lastID = 0;
    //we retrieve the last ID from nav link...	

    var re = new RegExp('<li><a href="/planche/fr(\\d+)[^\"]+">home &raquo;</a></li>');
    var match = re.exec(data);
    if ( match != null ) {	     
	lastID = match[1];
	print("last id = " +lastID);   
    }
    else {	

	  re = new RegExp('<img id="image" src="/strips/(\\d+)-fr\.png"');
	  match = re.exec(data);
	  if ( match != null ) {	     
	    lastID = match[1];
	    print("last id = " +lastID);   
	  }
	  else {
	    print("cannot parse last id");
	  }
    }

    return parseInt(lastID);
}

function getNextID(data)
{
    var nextID = 0;
    //we retrieve the next ID from nav link...	
    var re = new RegExp('<li class="next"><a href="/planche/fr(\\d+)/.*"');
    var match = re.exec(data);
    if ( match != null ) {	     
	nextID = match[1];
	print("next id = " +nextID);   
    }
    else {	
	  print("cannot parse next id");
	  nextID = comic.lastIdentifier;
	}

    return parseInt(nextID);
}

function getPrevID(data)
{
   var prevID = 0;
    //we retrieve the prev ID from nav link...	
    var re = new RegExp('<li class="prev"><a href="/planche/fr(\\d+)/.*"');
    var match = re.exec(data);
    if ( match != null ) {	     
	prevID = match[1];
	print("prev id = " +prevID);   
    }
    else {	
	  print("cannot parse prev id");
	}

    return parseInt(prevID); 
}


function getAdditionnalText(data)
{

	
}


function getAuthor(data)
{
    var author ="<unknown>";
    //we retrieve the last ID from nav link...	
    var re = new RegExp('<meta http-equiv="author" content="([^\"]+)"/>');
    var match = re.exec(data);
    if ( match != null ) {	     
	author = match[1];
	print("author = " +author);   
    }
    else {	
	  print("cannot parse last id");
	}
    return author;	
}

function getImageUrl(data)
{
     var url ="<unknown>";
    //we retrieve the last ID from nav link...	
    var re = new RegExp('<img id="image" src="/(strips/\\d+-fr\.png)"');
    var match = re.exec(data);
    if ( match != null ) {	     
	url = URL + match[1];
	print("img url = " +url);   
    }
    else {	
	  print("cannot parse image url");
	}
    return url;

}

function pageRetrieved(id, data)
{
  
    if (id == comic.User) {
    	//find the most recent strip
	var lastid = getLastID(data);	

        comic.identifier = lastid;	   
        comic.requestPage(websiteUrl(lastid), comic.Page);        
    }
    if( id == comic.Page) {
    	print("parsing page for id :" + comic.identifier);

        //set the current url
	comic.websiteUrl = websiteUrl(comic.identifier);
	
	//retrieve the title
        comic.title = getTitle(data);	

         //retrieve the last  ID	
	comic.lastIdentifier = getLastID(data);
	comic.nextIdentifier = getNextID(data);
	comic.previousIdentifier = getPrevID(data);
	//retrieve the author
	comic.comicAuthor = getAuthor(data);	
	
	//load the image
    	comic.requestPage(getImageUrl(data),comic.Image);       
    }

}
