/*
 *   Copyright (C) 2008 Matthias Fuchs <mat69@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

function init()
{
    comic.comicAuthor = "Johnny Hart";
    comic.firstIdentifier = "2000-04-12";
    comic.websiteUrl = "http://comics.com/bc/";

    var today = date.currentDate();
    var findNewDate = ( comic.identifier.date >= today.date );

    if ( findNewDate ) {
        comic.requestPage( comic.websiteUrl, comic.User );
    } else {
        comic.websiteUrl += comic.identifier.toString( date.ISODate ) + "/";
        comic.requestPage( comic.websiteUrl, comic.Page );
    }
}

function pageRetrieved( id, data ) {
    //find lastIdentifier
    if ( id == comic.User ) {
        const expLast = new RegExp( "<a href=\"http://comics.com/bc/(\\d{4}-\\d{2}-\\d{2})/\"" );
        const matchLast = expLast.exec( data );
        if ( matchLast != null ) {
            comic.lastIdentifier = date.fromString( matchLast[1], date.ISODate );
            comic.websiteUrl += comic.identifier.toString( date.ISODate ) + "/";
            comic.requestPage( comic.websiteUrl, comic.Page );
        } else {
            comic.error();
        }
    }
    if ( id == comic.Page ) {
        const expImage = new RegExp( "<img src=\"(http://assets.comics.com/dyn/str_strip/(\\d+/)+\\d+\\.full[^\"]+)\"" );
        const matchImage = expImage.exec( data );
        if ( matchImage != null ) {
            comic.requestPage( matchImage[1], comic.Image );
        } else {
            comic.error();
        }

        const expPrev = new RegExp( "Link_Previous: '/bc/(\\d{4}-\\d{2}-\\d{2})/'" );
        const matchPrev = expPrev.exec( data );
        if ( matchPrev != null ) {
            comic.previousIdentifier = date.fromString( matchPrev[1], date.ISODate );
        }

        const expNext = new RegExp( "Link_Next: '/bc/(\\d{4}-\\d{2}-\\d{2})/'" );
        const matchNext = expNext.exec( data );
        if ( matchNext != null ) {
            comic.nextIdentifier = date.fromString( matchNext[1], date.ISODate );
        }
    }
}
