/***************************************************************************
 *   Copyright (C) 2018 Matthias Fuchs <mat69@gmx.net>                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

function init()
{
    comic.comicAuthor = "Joscha Sauer";
    comic.firstIdentifier = "2000-05-01";
    comic.websiteUrl = "https://joscha.com/nichtlustig/";

    if (comic.identifierSpecified) {
        comic.websiteUrl += comic.identifier.toString("yyMMdd") + "/";
        comic.requestPage(comic.websiteUrl, comic.Page);
    } else {
        comic.requestPage("https://joscha.com/nichtlustig/", comic.User);
    }
}

function pageRetrieved(id, data)
{
    var re = new RegExp("<meta property=\"og:image\" content=\"(https://joscha.com/data/media/cartoons/share/(\\d{6}).jpg)");
    var match = re.exec(data);
    if (match == null) {
        print("No comic found.");
        comic.error();
        return;
    }
    var comicUrl = match[1];

    if (id == comic.User) {
        comic.lastIdentifier = date.fromString("20" + match[2], "yyyyMMdd");
        comic.websiteUrl += comic.identifier.toString("yyMMdd") + "/";
    }

    // Previous
    re = new RegExp("<div id=\"comic_navigation\"><a href=\"https://joscha.com/nichtlustig/(\\d{6})/\" class=\"thumbscroller_navigation inactive\" data-direction=\"next\"");
    match = re.exec(data);
    if (match != null && comic.websiteUrl != match[1] && match[1] != "000501") {
        comic.previousIdentifier = date.fromString("20" + match[1], "yyyyMMdd");
    }

    // Next
    re = new RegExp("<a href=\"(https://joscha.com/nichtlustig/(\\d{6})/)\" class=\"thumbscroller_navigation inactive\" data-direction=\"prev\"");
    match = re.exec(data);
    if (match != null && comic.websiteUrl != match[1]) {
        comic.nextIdentifier = date.fromString("20" + match[2], "yyyyMMdd");
    }

    // Cartoon
    comic.requestPage(comicUrl, comic.Image);
}
