/*
 *   Copyright (C) 2009 Mathias Panzenböck <grosser.meister.morti@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

const mainPage = 'http://www.ozyandmillie.org/';
const GetLast  = comic.User;
const GetNext  = comic.User + 1;

function init() {
	comic.comicAuthor     = "Dana Simpson";
	comic.firstIdentifier = "19980429";
	comic.shopUrl         = 'http://www.cafepress.com/ozyandmillie';

	if (!comic.identifierSpecified) {
		comic.requestPage(mainPage, GetLast);
	}
	else {
		var re = /^next-of-(\d+)$/;
		var match = re.exec(comic.identifier);
		if (match == null) {
			comic.requestPage('http://www.ozyandmillie.org/d/' + comic.identifier + '.html', comic.Page);
		}
		else {
			comic.requestPage('http://www.ozyandmillie.org/d/' + match[1] + '.html', GetNext);
		}
	}
}

function pageRetrieved(id, data) {
	if (id == comic.Image) {
		return;
	}

	var re, match;

	if (id == GetNext) {
		re = /<a href="([^"]*)"><img [^>]*id="next_day1"/;
		match = re.exec(data);

		if (match == null || match[1] == '/') {
			comic.requestPage(mainPage, GetLast);
		}
		else {
			comic.requestPage('http://www.ozyandmillie.org/d/' + match[1] + '.html', comic.Page);
		}
		return;

	}
	
	// find the most recent comic
	re = /<img [^>]*src="(\/comics\/om(\d+)(?:\D[^"]*)?\.\w+)"/;
	match = re.exec(data);

	if (match == null) {
		print("*** error: could not parse image url for " + comic.identifier);
		comic.error();
		return;
	}

	var comicId = match[2];

	if (id == GetLast) {
		comic.lastIdentifier = comicId;
	}

	if (!comic.identifierSpecified) {
		comic.identifier = comicId;
	}

	comic.websiteUrl = 'http://www.ozyandmillie.org/d/' + comicId + '.html';

	// getting the image
	comic.requestPage('http://www.ozyandmillie.org' + match[1], comic.Image);

	// getting the previous identifier	
	re = /<a href="\/d\/(\d+)\.html"><img [^>]*id="previous_day1"/;
	match = re.exec(data);
	if (match != null) {
		comic.previousIdentifier = match[1];
	}

	// getting the next identifier
	re = /<a href="([^"]*)"><img [^>]*id="next_day1"/;
	match = re.exec(data);
	if (match != null) {
		var s = match[1];
		if (s == '/') {
			if (comic.lastIdentifier == undefined) {
				comic.nextIdentifier = 'next-of-' + comicId;
			}
			else {
				comic.nextIdentifier = comic.lastIdentifier;
			}
		}
		else {
			re = /\/d\/(\d+)\.html/;
			match = re.exec(s);
			
			if (match != null) {
				comic.nextIdentifier = match[1];
			}
		}
	}
}
