/***************************************************************************
 *   Copyright (C) 2018 Matthias Fuchs <mat69@gmx.net>                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

function init()
{
    comic.comicAuthor = "Jeph Jacques";
    comic.shop = "https://topatoco.com/collections/jeph-jacques";
    var url = "https://www.questionablecontent.net/index.php";

    comic.requestPage(url, comic.User);
}

function pageRetrieved(id, data)
{
    var re = new RegExp("comics/((\\d+)\\.(jpg|png|gif))")
    var match = re.exec (data);

    //find the most recent comic
    if (id == comic.User) {
        if (match != null) {
            comic.lastIdentifier = match[2];
        } else {
            print("Did not find most recent comic.");
            comic.error();
            return;
        }

        comic.websiteUrl = "https://www.questionablecontent.net/view.php?comic=" + comic.identifier;
        comic.requestPage(comic.websiteUrl, comic.Page);
    }
    if (id == comic.Page) {
        if (match != null) {
            var url = "https://www.questionablecontent.net/comics/" + match[1];
            comic.requestPage(url, comic.Image);
        } else {
            print("Failed finding comic image.");
            comic.error();
            return;
        }

        var str = new String(data);
        var start = str.indexOf("<div id=\"news\"");
        var end = str.indexOf("</div>", start + 1);
        if ((start != -1) && (end != -1)) {
            comic.additionalText = str.slice(start, end);
            comic.additionalText = comic.additionalText.replace("<br /><br />", "");//remove empty lines at beginning
        }
    }
}
