/*
 *   Copyright (C) 2009 Todd
 *
 *   Based on the XKCD comic engine by Tobias Koenig <tokoe@kde.org>
 *   and Matthias Fuchs <mat69@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

function init()
{
    comic.comicAuthor = "Greg Dean";
    comic.websiteUrl = "http://www.reallifecomics.com/";
    comic.shopUrl = "http://store.reallifecomics.com/";
    comic.firstIdentifier= date.fromString("991115","yyMMdd");
    comic.requestPage(comic.websiteUrl, comic.User);

}

function pageRetrieved(id, data)
{
    var re
    var match

    //find the most recent strip
    if (id == comic.User) {
        re = new RegExp("<a href=\"/store/item/prints\\.html\\?strip=(\\d+)");
        match = re.exec(data);

        if ( match != null ) {
            if (parseInt(match[1].slice(0,1)) < 9) {
                comic.lastIdentifier = date.fromString("20" + match[1],"yyyyMMdd");
            } else {
                comic.lastIdentifier = date.fromString("19" + match[1],"yyyyMMdd");
            }
            comic.websiteUrl += "archive/" + comic.identifier.toString("yyMMdd") + ".html";
            comic.requestPage(comic.websiteUrl, comic.Page);
        } else {
            comic.error();
            return;
        }
    }

    //find the target strip
    if (id == comic.Page) {
        comic.websiteUrl = "http://www.reallifecomics.com/";
        re = new RegExp("<!--AIO_START--><img src=\"/(comics/\\d+/\\d+_\\d+\\.\\w+)\"");
        match = re.exec(data);
        if (match != null) {
            comic.requestPage(comic.websiteUrl + match[1], comic.Image);
        } else {
            comic.error();
            return;
        }

        re = new RegExp("<a href=\"/archive/(\\d+).html\"><img src=\"/images/nav_next.png\" alt=\"Next Comic\"");
        match = re.exec(data);
        if ( match != null ) {
            if (parseInt(match[1].slice(0,1)) < 9) {
                comic.nextIdentifier = date.fromString("20" + match[1],"yyyyMMdd");
            } else {
                comic.nextIdentifier = date.fromString("19" + match[1],"yyyyMMdd");
            }
        }

        re = new RegExp("<a href=\"/archive/(\\d+).html\"><img src=\"/images/nav_previous.png\" alt=\"Previous Comic\"");
        match = re.exec(data);
        if ( match != null ) {
            if (parseInt(match[1].slice(0,1)) < 9) {
                comic.previousIdentifier = date.fromString("20" + match[1],"yyyyMMdd");
            } else {
                comic.previousIdentifier = date.fromString("19" + match[1],"yyyyMMdd");
            }
        }
    }
}
