/***************************************************************************
 *   Copyright (C) 2009 Dario Abatianni <eisfuchs@tigress.com>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

// For development information see:
// http://techbase.kde.org/Development/Tutorials/Plasma/ComicPlugin

function init()
{
    comic.comicAuthor = "Phillip M. Jackson";
    comic.firstIdentifier = "1";
    comic.websiteUrl = "http://collectedcurios.com/sequentialart.php";

    if ( !comic.identifierSpecified )
    {
        comic.requestPage( comic.websiteUrl, comic.User );
    }
    else
    {
        comic.requestPage( comic.websiteUrl + "?s=" + comic.identifier, comic.Page );
    }
}

function pageRetrieved(id, data)
{
    if ( id == comic.User )
    {
        var expLast = new RegExp( "s=([0-9]+)\"><img src=\"Nav_Last" );
        var matchLast = expLast.exec( data );

	if ( matchLast == null)
	{
	    delete expLast;
	    expLast = new RegExp( "<input type=\"text\" name=\"s\" value=\"([0-9]+)\"" );
	    matchLast = expLast.exec( data );
	}

        if ( matchLast != null )
	{
            comic.lastIdentifier = matchLast[1];
            comic.identifier = comic.lastIdentifier;
            comic.websiteUrl += "?s=" + comic.identifier;
            comic.requestPage( comic.websiteUrl, comic.Page );
        }
	else
	{
            comic.error();
        }
    }
    else if ( id == comic.Page )
    {
        const expComic = new RegExp( "<input type=\"text\" name=\"s\" value=\"([0-9]+)\"" );
        const matchComic = expComic.exec( data );
        if ( matchComic != null )
	{
	    var num = matchComic[1];
	    if ( num < 10 )
	    {
	        num = "000" + num;
	    }
	    else if ( num < 100 )
	    {
	        num = "00" + num;
	    }
	    else if ( num < 1000 )
	    {
	        num = "0" + num;
	    }
            comic.requestPage("http://collectedcurios.com/SA_" + num + "_small.jpg", comic.Image );
        }
	else
	{
            comic.error();
        }

        const expPrev = new RegExp( "s=([0-9]+)\"><img src=\"Nav_BackOne" );
        const matchPrev = expPrev.exec( data );
        if ( matchPrev != null )
	{
            comic.previousIdentifier = matchPrev[1];
        }

        const expNext = new RegExp( "s=([0-9]+)\"><img src=\"Nav_ForwardOne" );
        const matchNext = expNext.exec( data );
        if ( matchNext != null )
	{
            comic.nextIdentifier = matchNext[1];
        }
    }
}
