/*
 * Copyright (C) 2007 Tobias Koenig <tokoe@kde.org>
 * Copyright (C) 2009 - 2017 Matthias Fuchs <mat69@gmx.net>
 * Copyright (C) 2019 MirceaKitsune <mirceakitsune@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License version 2 as
 * published by the Free Software Foundation
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * http://techbase.kde.org/Development/Tutorials/Plasma/ComicPlugin
 */

function init()
{
	comic.comicAuthor = "Tom Fischbach";
	comic.websiteUrl = "http://twokinds.keenspot.com/";
	comic.shopUrl = "http://keenspotshop.com/collections/twokinds";

	comic.requestPage(comic.websiteUrl, comic.User);
}

function pageRetrieved(id, data)
{
	// find the most recent strip
	if(id == comic.User) {
		var re = new RegExp("<a href=\"/comic/(\\d+)/\">Permalink</a>");
		var match = re.exec(data);
		if(match != null) {
			comic.lastIdentifier = match[1];
			comic.websiteUrl += "comic/" + comic.identifier + "/";
			comic.requestPage(comic.websiteUrl, comic.Page);
		} else {
			comic.error();
		}
	}

	// load the selected strip
	if(id == comic.Page) {
		var re = new RegExp("src=\"(http://cdn\.twokinds\.keenspot\.com/comics/[^\"]+)\"");
		var match = re.exec(data);
		if(match != null) {
			comic.requestPage(match[1], comic.Image);
		} else {
			comic.error();
			return;
		}

		re = new RegExp("<h1>([^\"]+)</h1>");
		match = re.exec(data);
		if(match != null) {
			comic.title = match[1];
			comic.additionalText = match[1];
		}
	}
}
