/*
 *   Copyright (C) 2009 Mathias Panzenböck <grosser.meister.morti@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

const comicPrefix = 'http://wallyandosborne.com';

function init() {
	comic.comicAuthor     = 'Tyler Martin';
	comic.firstIdentifier = '/2005/06/27/welcome-to-antarctica/';
	comic.shopUrl         = 'http://wallyandosborne.com/original-art-sale/';
	
	if (comic.identifierSpecified) {
		comic.requestPage(comicPrefix + comic.identifier, comic.Page);
	}
	else {
		comic.requestPage('http://wallyandosborne.com/', comic.Page);
	}
}

function pageRetrieved(id, data) {
	if (id == comic.Image) {
		return;
	}

	var re = /<img src="(http:\/\/wallyandosborne\.com\/comics\/[^"]*)" alt="([^"]*)"/;
	var match = re.exec(data);

	if (match == null) {
		print('*** could not parse comic for: ' + comic.identifier);
		comic.error();
		return;
	}

	comic.requestPage(match[1], comic.Image);
	comic.title = match[2];

	if (!comic.identifierSpecified) {
		re = /<a href="http:\/\/wallyandosborne\.com(\/[^"]*)" rel="bookmark"/;
		match = re.exec(data);
		if (match == null) {
			print('*** could not find permalink for current comic');
		}
		else {
			comic.identifier = comic.lastIdentifier = match[1];
		}
	}
	comic.websiteUrl = comicPrefix + comic.identifier;

	re = /<a href="http:\/\/wallyandosborne\.com(\/[^"]*)">&lsaquo; Previous<\/a>/;
	match = re.exec(data);
	if (match != null) {
		comic.previousIdentifier = match[1];
	}

	re = /<a href="http:\/\/wallyandosborne\.com(\/[^"]*)">Next &rsaquo;<\/a>/;
	match = re.exec(data);
	if (match != null) {
		comic.nextIdentifier = match[1];
	}
}
