/*
 *   Copyright (C) 2009 Eric Johnson <emj10 AT YOU KNOW DELETE THAT vt.edu>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
var url = "http://wondermark.com/";

function init()
{
    comic.comicAuthor = "David Malki !";
    comic.websiteUrl = "http://wondermark.com/";
    comic.shopUrl = "http://store.wondermark.com/";
    comic.firstIdentifier = "001";
    comic.websiteUrl += comic.identifier;
    comic.requestPage(comic.websiteUrl, comic.Page);
}

function pageRetrieved(id, data)
{
    //find the most recent strip
    if (id == comic.User) {
        // first try and match against number
        var re = new RegExp("Permalink to this comic: http://wondermark.com/(\\d+)/");
        var match = re.exec(data);
        if ( match != null ) {
            comic.lastIdentifier = match[1];
            comic.websiteUrl = url + comic.identifier + "/";
            comic.requestPage(comic.websiteUrl, comic.Page);
        } else {
            // if the first attempt didn't work, try matching against guest strip with lazy match
            re = new RegExp("Permalink to this comic: http://wondermark.com/(guest-.+?)/");
            match = re.exec(data);
            if ( match != null ) {
                comic.lastIdentifier = match[1];
                comic.websiteUrl = url + comic.identifier + "/";
                comic.requestPage(comic.websiteUrl, comic.Page);
            } else {
                // fail
                comic.error();
            }
        }
    }
    if (id == comic.Page) {
        var re = new RegExp("<img src=\"(http://wondermark.com/c/[^\"]+)\"");
        var match = re.exec(data);
        if (match != null) {
            comic.requestPage(match[1], comic.Image);
        } else {
            comic.error();
            return;
        }

        //find the tooltip and the strip title of the comic
        re = new RegExp("src=\"http://wondermark.com/c/[^\"]+\" title=\"([^\"]+)\" alt=\"([^\"]+)\"");
        match = re.exec(data);
        if (match != null) {
            comic.title = match[1];
            comic.additionalText = match[2];
        } else {
            //try with alt and title switched
            re = new RegExp("src=\"http://wondermark.com/c/[^\"]+\" alt=\"([^\"]+)\" title=\"([^\"]+)\"");
            match = re.exec(data);
            if (match != null) {
                comic.additionalText = match[1];
                comic.title = match[2];
            }
        }
        
        //find the previous link
        re = new RegExp("<div class=\"comic-nav-previous\">\\s+<a href=\"http://wondermark.com/([^\"]+)\"");
        match = re.exec(data);
        if (match != null) {
            comic.previousIdentifier = match[1];
        }
        
        //find the next link
        re = new RegExp("<div class=\"comic-nav-next\">\\s+<a href=\"http://wondermark.com/([^\"]+)\"");
        match = re.exec(data);
        if (match != null) {
            comic.nextIdentifier = match[1];
        }
    }
}
