/***************************************************************************
 *   Copyright (C) 2018 Matthias Fuchs <mat69@gmx.net>                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

function init()
{
    comic.comicAuthor = "Mikael Wulff, Anders Morgenthaler";
    comic.firstIdentifier = "2012-12-06";
    comic.websiteUrl = "http://wumo.com/wumo/";
    comic.shop = "";

    comic.requestPage(comic.websiteUrl, comic.User);
}

function pageRetrieved(id, data)
{
    //find the most recent comic
    if (id == comic.User) {
        var exp = new RegExp("<a href=\"http://wumo.com/wumo/(\\d{4}/\\d{2}/\\d{2})\"");
        var match = exp.exec(data);
        if (match != null) {
            comic.lastIdentifier = date.fromString(match[1], "yyyy/MM/dd");
            comic.websiteUrl += comic.identifier.toString("yyyy/MM/dd");
            comic.requestPage(comic.websiteUrl, comic.Page);
        } else {
            print("Failed to get the most recent strip.");
            comic.error();
            return;
        }
    }
    if (id == comic.Page) {
        var exp = new RegExp("property=\"og:image\" content=\"([^\"]+)\"");
        var match = exp.exec(data);
        if (match != null) {
            var url = match[1];
            comic.requestPage(url, comic.Image);
        } else {
            print("Failed to get image.");
            comic.error();
            return;
        }

        exp = new RegExp("class=\"prev\" href=\"/wumo/(\\d{4}/\\d{2}/\\d{2})\"");
        match = exp.exec(data);
        if (match != null) {
            comic.previousIdentifier = date.fromString(match[1], "yyyy/MM/dd");
        }

        exp = new RegExp("class=\"next\" href=\"/wumo/(\\d{4}/\\d{2}/\\d{2})\"");
        match = exp.exec(data);
        if (match != null) {
            comic.nextIdentifier = date.fromString(match[1], "yyyy/MM/dd");
        }
    }
}
