/*
 *   Copyright (C) 2007 Tobias Koenig <tokoe@kde.org>
 *   Copyright (C) 2009 Matthias Fuchs <mat69@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

function init()
{
    comic.comicAuthor = "Randall Munroe";
    comic.websiteUrl = "http://es.xkcd.com/";
    comic.shopUrl = "http://store.xkcd.com/";
    comic.textCodec = "UTF-8";
    comic.firstIdentifier = "strips/pong/";
    if (comic.identifier != new String()) {
      comic.websiteUrl = "http://es.xkcd.com/" + comic.identifier;
      comic.requestPage(comic.websiteUrl, comic.Page);
    } else {
      comic.requestPage(comic.websiteUrl, comic.User);
    }
}

function pageRetrieved(id, data)
{
  //find the most recent strip
  if (id == comic.User) {
    var re = new RegExp("Enlace permanente a esta tira: http://es.xkcd.com/([^\<]+)</h3>");
    var match = re.exec(data);
    if ( match != null ) {
      comic.lastIdentifier = match[1];
      comic.identifier = comic.lastIdentifier;
      comic.websiteUrl += comic.identifier;
      comic.requestPage(comic.websiteUrl, comic.Page);
    } else {
      comic.error();
    }
  }
  if (id == comic.Page) {
    //find the image, tooltip and the strip title of the comic
    var re = new RegExp("<img alt=\"([^\"]+)\" title=\"([^\"]+)\" class=\"strip\" src=\"([^\"]+)\">");
    var match = re.exec(data);
    if (match != null) {
      comic.title = match[1];
      comic.additionalText = match[2];
      comic.requestPage("http://es.xkcd.com" + match[3], comic.Image);
    }
   
    //getting the previous identifier
    re = new RegExp("<li><a href=\"http://es.xkcd.com/([^\"]+)\" accesskey=\"a\">");
    match = re.exec(data);
    if (match != null) {
      print(match[1]);
      comic.previousIdentifier = match[1];
    }
    //getting the next identifier
    re = new RegExp("<li><a href=\"http://es.xkcd.com/([^\"]+)\" accesskey=\"s\">");
    match = re.exec(data);
    if (match != null) { // this is the last
      print(match[1]);
      comic.nextIdentifier = match[1];
    }
  }
}
