/*
 *   Copyright (C) 2009 Todd
 *
 *   Based on the XKCD comic engine by Tobias Koenig <tokoe@kde.org>
 *   and Matthias Fuchs <mat69@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

function init()
{
    comic.comicAuthor = "Kabutroid";
    comic.websiteUrl = "http://www.zebeth.com/planetzebeth/";
    comic.shopUrl = "http://www.zebeth.com/planetzebeth/stuff/index.html";

    if (comic.identifier == 0) {
        comic.requestPage(comic.websiteUrl, comic.User);
    } else if (comic.identifier < 1000) {
        comic.websiteUrl += "archives/z" + String("000" + comic.identifier).slice(-3) + ".html";
        comic.requestPage(comic.websiteUrl, comic.Page);
    } else {
        comic.websiteUrl += "archive1k/z" + comic.identifier + ".html";
        comic.requestPage(comic.websiteUrl, comic.Page);
    }
}

function pageRetrieved(id, data)
{
    //find the most recent strip
    if (id == comic.User) {
        var re = new RegExp("z(\\d+)\\.html\"><img src=\"back\\.gif\"");
        var match = re.exec(data);

        if ( match != null ) {
            comic.lastIdentifier = parseInt(match[1])+1;
            if ( comic.identifier < 1000 ) {
                comic.websiteUrl += "archives/z" + String("000" + comic.identifier).slice(-3) + ".html";
            } else {
                comic.websiteUrl += "archive1k/z" + comic.identifier + ".html";
            }
            comic.requestPage(comic.websiteUrl, comic.Page);
        } else {
            comic.error();
            return;
        }
    }

    //find the target strip
    if (id == comic.Page) {
        var heading = "";
        comic.websiteUrl = "http://www.zebeth.com/planetzebeth/"
        if (comic.identifier < 1000) {
            comic.websiteUrl += "archives/";
        } else {
            comic.websiteUrl += "archive1k/";
        }
 
        var re = new RegExp("<img src=\"(z\\d+\\.(png|gif|jpg|jpeg))\"");
        var match = re.exec(data);
        if (match != null) {
            comic.requestPage(comic.websiteUrl + match[1], comic.Image);
        } else {
            re = new RegExp("<embed src=\"http://www\\.youtube\\.com/v/(\\w+)\"");
            match = re.exec(data);
         
            if (match != null) {
                comic.requestPage("http://img.youtube.com/vi/" + match[1] + "/1.jpg", comic.Image);
                heading = "YouTube Video: ";
            } else {            
                comic.error();
                return;
            }
        }
        
        //find the tooltip and title of the comic            
            re = new RegExp("=\"Strip (\\d+): ([^\"]+)\"");
            match = re.exec(data);
            if (match != null) {
                comic.title = heading + match[2];
            } else {
                re = new RegExp("<br><br><h2><font color=\"red\" face=\"small fonts\">([^<]+)</font>");
                match = re.exec(data);
                if (match != null) {
                    comic.title = heading + match[1];
                }
            }

        re = new RegExp("</center><hr><b>\n*(\.+)\n*</b>");
        match = re.exec(data);
        if (match != null) {
            if (match[1] != "\n") {
                comic.additionalText = match[1];
            } else {
                comic.additionalText = "Strip " + comic.identifier + ": " + comic.title;
            }
        }

    }
}
